import HQJGFun from "./fun";
import { ApiCall } from "tsrpc";
import { ReqTaskRec, ResTaskRec } from "../../../shared/protocols/event/huangqijiuguan/PtlTaskRec";
import { PlayerFun } from "../../../public/player";

export default async function (call: ApiCall<ReqTaskRec, ResTaskRec>) {
    let hd = await HQJGFun.HdInfo(call, call.req.hdid);
    if (!hd || Object.keys(hd).length <= 0) {
        // 无此活动
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    let today = HQJGFun.today(hd);
    if (today < call.req.day) {
        // 未到领取时间
        return call.error('', { code: -1, message: globalThis.lng.hqjgtips_29 })
    }

    let prize = [];
    let taskday = `day${call.req.day}`
    let mydata = await HQJGFun.getMydata(call, hd);

    for (let id of call.req.taskid) {
        let con = hd.data.task[taskday][id];

        if (!con) {
            continue
        }

        if (mydata.task.rec[taskday] && mydata.task.rec[taskday].includes(id)) {
            continue
        }

        if (!mydata.task.val[taskday] || (mydata.task.val[taskday][id] || 0) < con.pval) {
            continue
        }

        prize = prize.concat(con.prize);
        mydata.task.rec[taskday] = (mydata.task.rec[taskday] || []).concat(id);
    }

    if (prize.length <= 0) {
        return call.error('', { code: -3, message: lng.hqjgtips_28 });
    }

    // 发送奖励
    await PlayerFun.sendPrize(call, prize);
    // 设置领取记录
    await HQJGFun.setMyData(call.uid, call.req.hdid, {task: mydata.task});

    call.succ({ data: mydata, prize: prize });

    G.server.sendMsgByUid(call.uid, "msg_s2c/HongDianChange", ["huodonghd"])
}   