import { ReqEmail } from "../monopoly/protocols/PtlEmail";
import { patchInit } from "../patch";
import { MsgEmail } from "../shared/protocols/msg_s2c/MsgEmail";
import { PublicShared } from "../shared/public/public";


class Path {
    async fun1(a: any) {
        let uids = [
            "4_6571ab682b3f80154e724f2a",
            "16_6575e1625685671e63fe001f",
            "13_6574ad08e7cc32b4bd1334e8",
            "13_65749bc319cab1affec349fb",
        ];

        // 删除玩家背包中的头像框
        let items = await G.mongodb.collection("item").find({ uid: { $nin: uids }, itemId: { $in: ["47", "48"] } }).toArray();
        for (let item of items) {
            console.log(`删除玩家${item.uid}的头像框道具${item.itemId}`);
            await G.mongodb.collection("item").updateOne({ _id: item._id }, { $set: { uid: `patch_del_${item.uid}` } });
        }

        // 删除玩家存在的头像框
        let users = await G.mongodb.collection("user").find({
            uid: { $nin: uids }, $or: [
                { ["headFrame.id"]: "8" },
                { ["headFrame.id"]: "14" },
                { ["headFrames.8"]: { $exists: true } },
                { ["headFrames.14"]: { $exists: true } },
            ]
        }).toArray();
        for (let user of users) {
            let change = { $set: {}, $unset: {} };
            if (user.headFrame?.id == "8" || user.headFrame?.id == "14") {
                change.$set = { headFrame: { id: "1", time: -1 } };
            }

            if (user.headFrames["8"] != undefined) {
                change.$unset["headFrames.8"] = 1;
            }

            if (user.headFrames["14"] != undefined) {
                change.$unset["headFrames.14"] = 1;
            }
            if (Object.keys(change.$set).length > 0 || Object.keys(change.$unset).length > 0) {
                console.log(`处理玩家${user.uid}数据：${JSON.stringify(change)}`);
                await G.mongodb.collection("user").updateOne({ _id: user._id }, change);
            }
        }
    }

    async run() {
        await this.fun1(1);
    }
}

async function main() {
    await patchInit()
    let patch = new Path();
    await patch.run();
    console.log("逻辑执行完成，等待退出");
    setTimeout(function () {
        console.log('结束程序');
        process.exit();
    }, 3000);
}

main();
